



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Flexbox 自由的布局</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Flexbox 自由的布局</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 17:27:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>css3提出了一种新的布局方式.她并没有以摧枯拉朽之势博得我的喜爱.我和她的故事总是伴随着苦涩的味道.世道变了,总要做出些选择才能跟紧步伐.她很强大,能满足你天马行空的需求而不必抓掉一大把头发.她却很复杂,属性之多让我多次在门外观望.一回生,二回熟.来往多了,竟也混熟了. 原来了解其核心思想和原理便可拨开云雾见明月.</p>
<p>以前都是用float + position 来定位布局.用过float的都知道,会涉及到清除浮动的问题以及BFC(块级格式化上下文),容易出现问题开发也麻烦.后来使用inline-block 布局规避掉清除浮动的问题,还能自适应内容宽度. 还能通过vertical-align:middle 来解决垂直居中的问题,但是移动开发的大潮来袭,inline-block对响应式布局上终究显得力不从心.伸缩盒模型应运而生,能轻松的解决诸如垂直居中,自适应,拉伸,响应式等等问题.让开发者从各种hack和多版本开发的重复劳动中解脱. 我个人认为这是非常有意义的.为了有一个直观的理解,咱们来看一些常见的布局,用flexbox是怎么做的:</p>
<p><strong>1. &nbsp;几个div水平排列,类似inline-block的效果</strong></p>
<p>可见只需要在父容器上设定一个display:flex 便可实现该效果,非常简单.</p>
<p><strong>2. &nbsp;垂直居中</strong></p>
<p><strong>3. &nbsp;2栏自适应布局</strong></p>
<p><strong>4. &nbsp;圣杯布局</strong></p>
<h2>Flexbox--弹性盒模型</h2>
<p>弹性盒子模型的出现是为了满足当今各种设备尺寸的自适应问题.它规定了一系列语法来表述项目如何在一个弹性盒子模型中自适应排列.这个盒子相对于其他元素是独立的,可以把它看成一个block元素,也可以是inline元素.它的语法可以分成2部分来看:</p>
<p><em><strong>对于弹性盒子的描述</strong></em></p>
<ul><li>flex-direction</li>
<li>flex-wrap</li>
<li>flex-flow</li>
<li>justify-content</li>
<li>align-items</li>
<li>align-content</li></ul>
<p><em><strong>对于盒子中元素的描述</strong></em></p>
<ul><li><code>order</code></li>
<li><code>flex-grow</code></li>
<li><code>flex-shrink</code></li>
<li><code>flex-basis</code></li>
<li><code>flex</code></li>
<li><code>align-self</code></li></ul>
<h2><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/596947/201604/596947-20160425232707877-1147217318.png" /></h2>
<h2>按术语分类</h2>
<p>flexbox的属性比较多,我们需要配合它的基本设计概念来辅助记忆.根据上图,我们按术语进行分类:</p>
<ul><li><em><strong>弹性容器(Flex container)</strong>　</em>　</li></ul>
<p>　　　包含着弹性项目的父元素。通过设置&nbsp;<a href="https://developer.mozilla.org/zh-CN/docs/Web/CSS/display" rel="external nofollow noreferrer"><code>display</code></a>&nbsp;属性的值为&nbsp;<code>flex</code>&nbsp;或&nbsp;<code>inline-flex</code>&nbsp;来定义弹性容器。</p>
<ul><li><em><strong>弹性项目(Flex item)</strong></em></p>
<p>弹性容器的每个子元素都成为弹性项目。弹性容器直接包含的文本将包覆成匿名弹性项目。</p></li>
<li><em><strong>轴(Axis)</strong></em>
<p>每个弹性框布局包含两个轴。弹性项目沿其依次排列的那根轴称为<strong>主轴(main axis)</strong>。垂直于<strong>主轴</strong>的那根轴称为<strong>侧轴(cross axis)</strong>。</p>
<ul><li><code><a href="https://developer.mozilla.org/en-US/docs/Web/CSS/flex-direction" rel="external nofollow noreferrer">flex-direction</a></code>&nbsp;属性确立主轴。</li>
<li><a href="https://developer.mozilla.org/en-US/docs/Web/CSS/justify-content" rel="external nofollow noreferrer"><code>justify-content</code></a>&nbsp;属性定义了在当前行上弹性项目沿主轴如何排布。</li>
<li><a href="https://developer.mozilla.org/en-US/docs/Web/CSS/align-items" rel="external nofollow noreferrer"><code>align-items</code></a>&nbsp;属性定义了在当前行上弹性项目沿侧轴默认如何排布。</li>
<li><code><a href="https://developer.mozilla.org/en-US/docs/Web/CSS/align-items" rel="external nofollow noreferrer">align-</a>content 属性定义了在多行上弹性项目沿侧轴默认如何排布.</code></li>
<li><a href="https://developer.mozilla.org/en-US/docs/Web/CSS/align-self" rel="external nofollow noreferrer"><code>align-self</code></a>&nbsp;属性定义了单个弹性项目在侧轴上应当如何对齐，这个定义覆盖由<code>align-items</code>&nbsp;所确立的默认值。</li></ul></li></ul>
<ul><li><em><strong>方位(Direction)</strong></em></p>
<p>弹性容器的各个边（<strong>主轴起点(main start)</strong>/<strong>主轴终点(main end)</strong>和<strong>侧轴起点(cross start)</strong>/<strong>侧轴终点(cross end)</strong>）描述了弹性条目流的起点与终点。它们具体取决于弹性容器的主轴与侧轴以及由&nbsp;<code>writing-mode</code>&nbsp;确立的方向（从左到右、从右到左，等等）。</p>
<ul><li><a href="https://developer.mozilla.org/en-US/docs/Web/CSS/order" rel="external nofollow noreferrer"><code>order</code></a>&nbsp;属性将元素与序号组关联起来，并决定哪些元素先出现。</li>
<li><a href="https://developer.mozilla.org/en-US/docs/Web/CSS/flex-flow" rel="external nofollow noreferrer"><code>flex-flow</code></a>&nbsp;属性是&nbsp;<a href="https://developer.mozilla.org/en-US/docs/Web/CSS/flex-direction" rel="external nofollow noreferrer"><code>flex-direction</code></a>&nbsp;和&nbsp;<a href="https://developer.mozilla.org/en-US/docs/Web/CSS/flex-wrap" rel="external nofollow noreferrer"><code>flex-wrap</code></a>&nbsp;属性的简写，决定弹性项目如何排布。　　　　　</li></ul></li></ul>
<ul><li><em><strong>行(Line)</strong></em></p>
<p>根据&nbsp;<a href="https://developer.mozilla.org/en-US/docs/Web/CSS/flex-wrap" rel="external nofollow noreferrer"><code>flex-wrap</code></a>&nbsp;属性，弹性项目可以排布在单个行或者多个行中。此属性控制侧轴的方向和新行排列的方向。</p></li>
<li><em><strong>尺寸(Dimension)</strong></em>
<p>根据弹性容器的主轴与侧轴，弹性项目的宽和高相应称为<strong>主轴尺寸(main size)</strong>&nbsp;与&nbsp;<strong>侧轴尺寸(cross size)</strong>。</p>
<ul><li><code><a href="https://developer.mozilla.org/en-US/docs/Web/CSS/min-height" rel="external nofollow noreferrer">min-height</a></code>&nbsp;与&nbsp;<code><a href="https://developer.mozilla.org/en-US/docs/Web/CSS/min-width" rel="external nofollow noreferrer">min-width</a></code>&nbsp;属性初始值为 0。</li>
<li><a href="https://developer.mozilla.org/en-US/docs/Web/CSS/flex" rel="external nofollow noreferrer"><code>flex</code></a>&nbsp;属性是&nbsp;<a href="https://developer.mozilla.org/en-US/docs/Web/CSS/flex-grow" rel="external nofollow noreferrer"><code>flex-grow</code></a>、<a href="https://developer.mozilla.org/en-US/docs/Web/CSS/flex-shrink" rel="external nofollow noreferrer"><code>flex-shrink</code></a>&nbsp;和&nbsp;<a href="https://developer.mozilla.org/en-US/docs/Web/CSS/flex-basis" rel="external nofollow noreferrer"><code>flex-basis</code></a>&nbsp;属性的简写，确立弹性项目的伸缩性。</li></ul></li></ul>
<h2>新旧语法对比</h2>
<p>了解概念是学习一个东西的基石.可是要完成一个东西,经验是最宝贵的.学习的目的就是去使用,提高效率.纸上谈兵毫无意义.由于伸缩盒的规范经历了好几次大版本的修改,造成多个版本共同存在.</p>
<p>2009年7月 工作草案 (display: box;)　　<a href="//link.zhihu.com/?target=https%3A//www.w3.org/TR/2009/WD-css3-flexbox-20090723/" rel="external nofollow noreferrer">https://www.w3.org/TR/2009/WD-css3-flexbox-20090723/</a><br />
&nbsp;&nbsp;&nbsp; 2011年3月 工作草案 (display: flexbox;)<br />
&nbsp;&nbsp;&nbsp; 2011年11月 工作草案 (display: flexbox;)　<a href="//link.zhihu.com/?target=https%3A//www.w3.org/TR/2011/WD-css3-flexbox-20110322/" rel="external nofollow noreferrer">https://www.w3.org/TR/2011/WD-css3-flexbox-20110322/</a><br />
&nbsp;&nbsp;&nbsp; 2012年3月 工作草案 (display: flexbox;)<br />
&nbsp;&nbsp;&nbsp; 2012年6月 工作草案 (display: flex;)</p>
<p>2012年9月 候选推荐 (display: flex;)　　<a href="//link.zhihu.com/?target=https%3A//www.w3.org/TR/2012/WD-css3-flexbox-20120612/" rel="external nofollow noreferrer">https://www.w3.org/TR/2012/WD-css3-flexbox-20120612/</a></p>
<h4><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/596947/201604/596947-20160429170102175-2042524841.png" /></h4>
<p>上图列出了09年版和2012版的语法对比,11年的过渡语法版本就不说了. 目前就IE11支持.</p>
<p>由于09年版语法对多行支持不好，因此你最好在一个flex容器内仅包含一行子元素。</p>
<h2>跨浏览器兼容</h2>
<p>比较有趣的是,09年版支持情况非常好,除了ie.</p>
<p><strong>兼容性方案的处理是,写09年,和12年版本伸缩盒标准语法,以及相应的浏览器厂商前缀.跨浏览器写法支持任意安卓和ios</strong></p>
<p>09年版:</p>
<p><em><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/596947/201604/596947-20160429173023363-104253243.png" /></em></p>
<p>12年版:</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/596947/201604/596947-20160429182853097-646388633.png" /></p>
<h2>经验tips</h2>
<h4>伸缩盒兼容</h4>
<div>
<pre class="prettyprint linenums">.page-wrap {<br />
  display: -webkit-box;      /* OLD - iOS 6-, Safari 3.1-6 */<br />
  display: -moz-box;         /* OLD - Firefox 19- (buggy but mostly works) */<br />
  display: -ms-flexbox;      /* TWEENER - IE 10 */<br />
  display: -webkit-flex;     /* NEW - Chrome */<br />
  display: flex;             /* NEW, Spec - Opera 12.1, Firefox 20+ */<br />
 }</pre>
</div>
<h4>子元素按比例分配兼容</h4>
<div>
<pre class="prettyprint linenums">.page-item {<br />
   width: 20%;               /* For old syntax, otherwise collapses. */<br />
  -webkit-box-flex:;      /* OLD - iOS 6-, Safari 3.1-6 */<br />
  -moz-box-flex:;         /* OLD - Firefox 19- */<br />
  -webkit-flex:;          /* Chrome */<br />
  -ms-flex:;              /* IE 10 */<br />
  flex:;                  /* NEW, Spec - Opera 12.1, Firefox 20+ */<br />
}&nbsp;</pre>
</div>
<p><em><strong>其中的width属性非常重要,你可以设置任意值,但必须要有.如果不设,在某些浏览器上会出现无法正确按设定的比例分配剩余空间的情况.</strong></em></p>
<h2>参考</h2>
<ul><li>伸缩盒新旧语法详细查询 <a href="http://www.css88.com/book/css/properties/flex/flex-flow.htm" rel="external nofollow noreferrer">flexbox</a></li>
<li>我个人比较推荐阮一峰的2篇文章<a href="http://www.ruanyifeng.com/blog/2015/07/flex-grammar.html" rel="external nofollow noreferrer">Flex布局-语法篇</a>,<a href="http://www.ruanyifeng.com/blog/2015/07/flex-examples.html" rel="external nofollow noreferrer">Flex布局-实例篇</a>. 看过之后基本就知道如何使用flexbox布局了. 在此不做详细探讨.</li>
<li>W3C制定标准流程:
<p><em>工作草案（Working Draft）<br />最终公示（Last Call）<br />候选推荐标准（Candidate Recommendation）<br />提名推荐标准（Proposed Recommendation）<br />推荐标准（Recommendation）</em></p></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m2170q.html">&period;NET正则表达式基础入门（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7vw7jq.html">分享Kali Linux 2016&period;2第45周镜像</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4vy7eq.html">&period;ipynb文件 与ipython notebook</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kegz78.html">树状DP （poj 2342）</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qno4yg9.html">Identifier &amp;&num;39&semi;Logic&period;DomainObjectBase&period;&lowbar;isNew&amp;&num;39&semi; is not CLS-compliant</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1nlmg8.html">delphi android 中 Toast 的实现&lpar;老外写的UNIT&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1kmon9.html">双系统修改启动项顺序&amp;amp&semi;&amp;amp&semi;&amp;amp&semi;修改开机启动等待时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okx63x9.html">写后台SQL的一些心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kvl209.html">python从初识到精通1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1rw3dq.html">JS打开摄像头并截图上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyo74m9.html">CSS3的新特性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjwwvl8.html">Ambari部署时问题之Ambari Metrics无法启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwndyd8.html">eclipse juint4 出错！！！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlloppeq.html">MySQL函数GROUP&lowbar;CONCAT</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjdgrz9.html">FromData获取表单数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv21my8.html">mysql之 mysql&lowbar;config&lowbar;editor&sol;login-path 登录密码保护</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1ymlw9.html">Git学习系列之Debian或Ubuntu上安装Git详细步骤（图文详解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zke3o38.html">开源项目CIIP&lpar;企业信息管理系统框架&rpar;&period;2018&period;1&period;0910版更新介绍-上周工作总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv7g4xq.html">Python之机器学习K-means算法实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p06xeq.html">CATransaction：原子化操作、批量操作、整体设置、自动添加</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/kjqd509d.html">构建一个基本的前端自动化开发环境 &mdash;&mdash; 基于 Gulp 的前端集成解决方案（四）</a>
			</li>
						<li><a href="https://www.batexi.com/a/xrqln18o.html">总结：Mac前端开发环境的搭建（配置）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gm3z97.html">Mono为何能跨平台？聊聊CIL&lpar;MSIL&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rd7e80.html">SSH实战  &amp;&num;183&semi;  唯唯乐购项目（中）</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7zzg9e.html">ExtJS 4&period;2 Date组件扩展：添加清除按钮</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnjk28r.html">JavaScript权威指南 - 数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4z059z.html">Java学习之反射机制及应用场景</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwj3387.html">如何远程关闭一个ASP&period;NET Core应用？</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q255wq7.html">Java中Comparable与Comparator的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlo3xqo.html">jQuery可自动播放动画焦点图插件Koala</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
